=== debian/changelog ===
cairo-dock (3.6.0-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 18 Oct 2025 13:25:40 -0700

cairo-dock (3.6.0-ppa1~ubuntu22.04) jammy; urgency=medium

  * New upstream release.

 -- Daniel Kondor <kondor.dani@gmail.com>  Sun, 28 Sep 2025 22:51:32 +0100

cairo-dock (3.5.99-1) jammy; urgency=medium

  * New upstream release.
  * Initial support for Wayland.
  * Add a .service file for Systemd
  * Split out session files to a separate package.
  
 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:16:01 +0100

cairo-dock (3.5.0) unreleased

  * Update to 3.5.0
  * Several bug fixes since the last release.
  
 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:16:00 +0100
