=== debian/control ===
Source: cairo-dock
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Daniel Kondor <kondor.dani@gmail.com>
Build-Depends: cmake (>= 3.16.0),
               debhelper (>= 10),
               debhelper-compat (= 12),
               dpkg-dev (>= 1.16.1~),
               extra-cmake-modules,
               intltool,
               libcairo2-dev | libcairo-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libglib2.0-dev (>= 2.40.0),
               libglu1-mesa-dev | libglu-dev,
               libglvnd-dev | libgl-dev,
               libgtk-3-dev (>= 3.22.0),
               libgtk-layer-shell-dev (>= 0.6.0),
               libjson-c-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libwayland-bin,
               libxcomposite-dev,
               libxml2-dev,
               libxrandr-dev,
               libxrender-dev,
               libxtst-dev,
               pkgconf,
               quilt,
               systemd
Standards-Version: 4.5.0
Homepage: http://www.glx-dock.org/

Package: cairo-dock
Architecture: any
Depends: cairo-dock-core (= ${binary:Version}),
         cairo-dock-plug-ins (>= 3.6.0),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cairo-dock-gnome-session
Description: Metapackage for cairo-dock
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This is metapackage that provides the components necessary for running
 Cairo-dock. This installs a cairo-dock-core application and cairo-dock-plugins
 package easily.

Package: cairo-dock-core
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libwayland-egl1, ${misc:Depends}, ${shlibs:Depends}
Breaks: cairo-dock (<= 2.1.3.5-2), cairo-dock-plug-in-data (<< 3.6.0)
Replaces: cairo-dock (<= 2.1.3.5-2)
Provides: cairo-dock
Recommends: cairo-dock-plugins (>= 3.6.0), curl
Description: Light eye-candy fully themable animated dock for Linux desktop
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock-core application.

Package: cairo-dock-gnome-session
Architecture: any
Depends: cairo-dock-core (>= 3.6.0),
         cairo-dock-gnome-integration-plug-in,
         cairo-dock-plug-ins (>= 3.6.0),
         compiz | metacity,
         gnome-flashback,
         gnome-session-bin,
         gnome-settings-daemon (>= 3.24),
         ${misc:Depends}
Description: An X11 desktop session for Cairo-Dock
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides a desktop environment using Cairo-Dock, either the
 Compiz or Metacity window manager and GNOME components.

Package: cairo-dock-dev
Section: devel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: cairo-dock-core (= ${binary:Version}),
         libcairo2-dev | libcairo-dev,
         libcurl4-gnutls-dev,
         libdbus-glib-1-dev,
         libglib2.0-dev,
         libglu1-mesa-dev | libglu-dev,
         libglvnd-dev | libgl-dev,
         libgtk-3-dev (>= 3.22.0),
         libgtk-layer-shell-dev (>= 0.6.0),
         librsvg2-dev,
         libwayland-dev,
         libxcomposite-dev,
         libxml2-dev,
         libxrandr-dev,
         libxrender-dev,
         libxtst-dev,
         ${misc:Depends}
Description: Cairo-dock development file
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock development file.
