=== debian/watch ===
version=4
opts="searchmode=plain, \
  pgpmode=none, \
  dversionmangle=auto" \
https://api.github.com/repos/Cairo-Dock/cairo-dock-core/releases \
https://api.github.com/repos/Cairo-Dock/cairo-dock-core/tarball/@ANY_VERSION@ \
debian
